''*****************************
''*  Graphics Demo            *
''*  (C) 2005 Parallax, Inc.  *
''*****************************


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  '_stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack
  _stack = ($3000 + 100) >> 2 'accomodate display memory and stack

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $5000
  display_base = $5000

  lines = 5
  thickness = 2
  

VAR

  'long  mousex, mousey

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]

  byte  x[lines]
  byte  y[lines]
  byte  xs[lines]
  byte  ys[lines]

  byte sensor[4]
  long stack2[200]
  byte Smsg[30]
  
  
OBJ

  tv    : "tv"
  gr    : "graphics"
   

PUB init
     Smsg[0]:=0 
     COGNEW(startEngine,@stack2) 

PUB startEngine | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr,p,endTime,m

  'start tv
  
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  
  'Status(String("SD CARDFOUND")) 
  sensor[0]:=1
  sensor[1]:=1
  sensor[2]:=1
  sensor[3]:=1  
  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)


  'start and setup graphics
  gr.start
  gr.setup(16, 12, 128, 96, bitmap_base)

  
  repeat

    'clear bitmap
    gr.clear

    'draw spinning triangles
    gr.colorwidth(3,0)
    repeat i from 1 to 8
      gr.vec(0, 0, (k & $7F) << 3 + i << 5, k << 6 + i << 8, @vecdef)


                                                                     
    'draw small Player Name
    gr.colorwidth(3,14)
    gr.box(20,-80,100,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(70,-72,@pchip)

    'draw sensor 1 status
    if INA[18]==0
      gr.colorwidth(1,14)
      sensor[0]:=0
    else
      gr.colorwidth(3,14)
      sensor[0]:=1
      
    gr.box(-80,20,60,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(-50,28,@sensor1)

    'draw sensor 2 status
    if INA[19]==0
      gr.colorwidth(1,14)
      sensor[1]:=0
    else
      gr.colorwidth(3,14)
      sensor[1]:=1
    
    gr.box(-80,0,60,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(-50,8,@sensor2)

    'draw sensor 3 status
    if INA[20]==0
      gr.colorwidth(1,14)
      sensor[2]:=0
    else
      gr.colorwidth(3,14)
      sensor[2]:=1
    
    gr.box(-80,-20,60,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(-50,-12,@sensor3)

    'draw sensor 4 status
    if INA[21]==0
      gr.colorwidth(1,14)
      sensor[3]:=0
    else
      gr.colorwidth(3,14)
      sensor[3]:=1
      
    gr.box(-80,-40,60,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(-50,-32,@sensor4)


    ' Playing....
    'gr.colorwidth(3,14)
    'gr.box(-80,50,120,16)
    

    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(-90,-80,String("Analog Mode"))

    'gr.textmode(1,1,6,5)
    'gr.colorwidth(2,0)
    'gr.text(0,58,String("Now Playing: Hello"))
      
    gr.text(0,58,@Smsg)

    endTime:=cnt+510_000_000
    i:=0
    m:=Smsg[0]
    repeat
        repeat p from 0 to 3
          if ina[18+p] <> sensor[p]
            i:=1
            p:=5
        if cnt > endTime      ' Timeout
             i:=1
        if m <> Smsg[0]        ' Msg Update
          i:=1
            
    until i==1

    
 {{
    'draw incrementing digit
    if not ++numx & 7
      numchr++
    if numchr < "0" or numchr > "9"
      numchr := "0"
    gr.textmode(5,5,6,5)
    gr.colorwidth(1,8)
    'gr.colorwidth(2,0)  
    gr.text(-90,50,@numchr)
  }}
    'copy bitmap to display
  '  gr.copy(display_base)

    'increment counter that makes everything change
    k++

PUB str(stringptr) | i

   i:=0
   repeat strsize(stringptr)
    Smsg[i++]:=(byte[stringptr++])

   Smsg[i]:=0
    

DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200

pchip                   byte    "Audio Trip v1.0",0           'text
sensor1                  byte    "Sensor 1",0
sensor2                  byte    "Sensor 2",0
sensor3                  byte    "Sensor 3",0
sensor4                  byte    "Sensor 4",0